package com.sun.jndi.dns;

import javax.naming.CommunicationException;
import javax.naming.NamingException;
import java.util.Vector;

class ResourceRecords
{
    Vector<ResourceRecord> question;
    Vector<ResourceRecord> answer;
    Vector<ResourceRecord> authority;
    Vector<ResourceRecord> additional;
    boolean zoneXfer;
    
    ResourceRecords(byte[] array, int n, Header header, boolean zoneXfer) throws NamingException {
        this.question = new Vector();
        this.answer = new Vector();
        this.authority = new Vector();
        this.additional = new Vector();
        if (zoneXfer) {
            this.answer.ensureCapacity(8192);
        }
        this.zoneXfer = zoneXfer;
        this.add(array, n, header);
    }
    
    int getFirstAnsType() {
        if (this.answer.size() == 0) {
            return -1;
        }
        return ((ResourceRecord)this.answer.firstElement()).getType();
    }
    
    int getLastAnsType() {
        if (this.answer.size() == 0) {
            return -1;
        }
        return ((ResourceRecord)this.answer.lastElement()).getType();
    }
    
    void add(byte[] array, int n, Header header) throws NamingException {
        int n2 = 12;
        try {
            Object obj;
            for (int i = 0; i < header.numQuestions; n2 += obj.size(), ++i) {
                obj = new ResourceRecord(array, n, n2, true, false);
                if (!this.zoneXfer) {
                    this.question.addElement(obj);
                }
            }
            Object obj2;
            for (int j = 0; j < header.numAnswers; n2 += obj2.size(), ++j) {
                obj2 = new ResourceRecord(array, n, n2, false, !this.zoneXfer);
                this.answer.addElement(obj2);
            }
            if (this.zoneXfer) {
                return;
            }
            Object obj3;
            for (int k = 0; k < header.numAuthorities; n2 += obj3.size(), ++k) {
                obj3 = new ResourceRecord(array, n, n2, false, true);
                this.authority.addElement(obj3);
            }
        }
        catch (IndexOutOfBoundsException ex) {
            throw new CommunicationException("DNS error: corrupted message");
        }
    }
}
